#!/usr/bin/env python2
from PyKDE4 import kdecore,  kdeui
from PyKDE4.kdecore import *
from PyKDE4.kdeui import *
from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os
from MyDirRequester import *

class AkanthophisUi(KMainWindow):
  def __init__(self):
    super(AkanthophisUi, self).__init__()
    self.setupUi()
    self.setInitialValues()
    self.setTestValues()
    self.connectUiSlots()
    self.STACK_SETUP_PAGE = 0 
    self.STACK_PROGRESS_PAGE = 1
    self.OPTIONS_GENERAL_PAGE = 0
    self.OPTIONS_SEQUENCE_PAGE = 1
    self.OPTIONS_EXTENSIONS_PAGE = 2
    self.SEQUENCE_NUMERIC_PAGE = 0
    self.SEQUENCE_DATE_PAGE = 1
    
  def setupUi(self):
    
    mainWidget = QWidget()
    mainLayout = QVBoxLayout(mainWidget)
    self.layout().addWidget(mainWidget)
    
    self.mainStack = QStackedWidget() #The Stack
    setupPage = QWidget() # Setup page / page 1
    progressPage = QWidget() # Progress page / page 2
    self.mainStack.addWidget(setupPage)
    self.mainStack.addWidget(progressPage)
    
    mainLayout.addWidget(self.mainStack)
    
    setupLayout = QVBoxLayout(setupPage)
    optionsTabWidget = QTabWidget()
    optionsGeneralPage = QWidget()
    optionsSequencePage = QWidget()
    optionsExtensionsPage = QWidget()
    optionsTabWidget.addTab(optionsGeneralPage,"General")
    optionsTabWidget.addTab(optionsSequencePage,"Sequence")
    optionsTabWidget.addTab(optionsExtensionsPage,"Extension")
    
    setupLayout.addWidget(optionsTabWidget)
    
    optionsGeneralLayout = QFormLayout(optionsGeneralPage)
    self.baseUrlEdit = QLineEdit()
    self.downloadDirectoryEdit = MyDirRequester()
    self.maxConcurrentDownloadsEdit = QSpinBox()
    self.maxConcurrentDownloadsEdit.setMinimum(1)
    self.maxConcurrentDownloadsEdit.setMaximum(64)
    self.delayEdit = QSpinBox()
    self.delayEdit.setSingleStep(1000)
    self.delayEdit.setMaximum(60000)
    self.delayEdit.setMinimum(0)
    self.overwriteExistingEdit = QComboBox()
    self.overwriteExistingEdit.addItems(["Rename", "Skip", "Overwrite"])
    self.overwriteExistingEdit.setEditable(False)
    optionsGeneralLayout.addRow("Base Url: ", self.baseUrlEdit)
    optionsGeneralLayout.addRow("Download Directory: ",  self.downloadDirectoryEdit)
    optionsGeneralLayout.addRow("Overwrite Existing: ", self.overwriteExistingEdit)
    optionsGeneralLayout.addRow("Max Concurrent Downloads: ", self.maxConcurrentDownloadsEdit)
    optionsGeneralLayout.addRow("Delay Between Files (ms): ", self.delayEdit)
    
    optionsSequenceLayout = QVBoxLayout(optionsSequencePage)
    sequenceGroup = QGroupBox()
    sequenceGroup.setTitle("Sequence Type")
    
    self.downloadByDateButton = QRadioButton()
    self.downloadByDateButton.setText("Date Sequence")
    self.downloadByNumberButton = QRadioButton()
    self.downloadByNumberButton.setText("Numeric Sequence")
    sequenceGroupLayout = QHBoxLayout(sequenceGroup)
    sequenceGroupLayout.addWidget(self.downloadByNumberButton)
    sequenceGroupLayout.addWidget(self.downloadByDateButton)
   
    self.sequenceStack = QStackedWidget()
    sequenceNumericPage = QGroupBox()
    sequenceDatePage = QGroupBox()
    self.sequenceStack.addWidget(sequenceNumericPage)
    self.sequenceStack.addWidget(sequenceDatePage)
    
    optionsSequenceLayout.addWidget(sequenceGroup)
    optionsSequenceLayout.addWidget(self.sequenceStack)
    
    sequenceNumericPage.setTitle("Numeric Sequence")
    sequenceNumericLayout = QFormLayout(sequenceNumericPage)
    self.startNumberEdit = QSpinBox()
    self.startNumberEdit.setMaximum(1000000000)
    self.endNumberEdit = QSpinBox()
    self.endNumberEdit.setMaximum(1000000000)
    self.redundantZerosEdit = QSpinBox()
    self.totalDigitsEdit = QSpinBox()
    sequenceNumericLayout.addRow("Start Number", self.startNumberEdit)
    sequenceNumericLayout.addRow("End Number", self.endNumberEdit)
    sequenceNumericLayout.addRow("Redundant Zeros", self.redundantZerosEdit)
    sequenceNumericLayout.addRow("Total Digits", self.totalDigitsEdit)

    sequenceDatePage.setTitle("Date Sequence")
    sequenceDateContainerLayout = QVBoxLayout(sequenceDatePage)
    
    
    sequenceDateGeneralMainLayout = QFormLayout()
    sequenceDateGeneralPreviewLayout = QHBoxLayout()
    self.dateSequenceTabWidget = QTabWidget()
    self.dateSequenceFilterPage = QWidget()
    self.dateSequenceGeneralPage = QWidget()
    self.dateSequenceTabWidget.addTab(self.dateSequenceGeneralPage, "General")
    self.dateSequenceTabWidget.addTab(self.dateSequenceFilterPage, "Filter")
    sequenceDateGeneralLayout = QVBoxLayout(self.dateSequenceGeneralPage)
    
    sequenceDateContainerLayout.addWidget(self.dateSequenceTabWidget)
    sequenceDateDayFilterLayout = QHBoxLayout(self.dateSequenceFilterPage)
    sequenceDateDayFilterColumn1Layout = QVBoxLayout()
    sequenceDateDayFilterColumn2Layout = QVBoxLayout()
    sequenceDateDayFilterLayout.addLayout(sequenceDateDayFilterColumn1Layout)
    sequenceDateDayFilterLayout.addLayout(sequenceDateDayFilterColumn2Layout)
    self.dateFilterSundayButton = QCheckBox()
    self.dateFilterSundayButton.setText("Sunday")
    self.dateFilterMondayButton = QCheckBox()
    self.dateFilterMondayButton.setText("Monday")
    self.dateFilterTuesdayButton = QCheckBox()
    self.dateFilterTuesdayButton.setText("Tuesday")
    self.dateFilterWednesdayButton = QCheckBox()
    self.dateFilterWednesdayButton.setText("Wednesday")
    self.dateFilterThursdayButton = QCheckBox()
    self.dateFilterThursdayButton.setText("Thursday")
    self.dateFilterFridayButton = QCheckBox()
    self.dateFilterFridayButton.setText("Friday")
    self.dateFilterSaturdayButton = QCheckBox()
    self.dateFilterSaturdayButton.setText("Saturday")
    sequenceDateDayFilterColumn1Layout.addWidget(self.dateFilterSundayButton)
    sequenceDateDayFilterColumn1Layout.addWidget(self.dateFilterMondayButton)
    sequenceDateDayFilterColumn1Layout.addWidget(self.dateFilterTuesdayButton)
    sequenceDateDayFilterColumn1Layout.addWidget(self.dateFilterWednesdayButton)
    sequenceDateDayFilterColumn2Layout.addWidget(self.dateFilterThursdayButton)
    sequenceDateDayFilterColumn2Layout.addWidget(self.dateFilterFridayButton)
    sequenceDateDayFilterColumn2Layout.addWidget(self.dateFilterSaturdayButton)
    
    
    self.startDateEdit = KDateWidget()
    self.endDateEdit = KDateWidget()
    self.formatStringEdit = QLineEdit()
    sequenceDateGeneralMainLayout.addRow("Start Date",  self.startDateEdit)
    sequenceDateGeneralMainLayout.addRow("End Date", self.endDateEdit)
    sequenceDateGeneralMainLayout.addRow("Format String", self.formatStringEdit)
    
    
    previewLabel =  QLabel()
    previewLabel.setText("Format Preview: ")
    self.formatStringPreview = QLineEdit()
    self.formatStringPreview.setEnabled(False)
    self.formatStringHelpButton = QPushButton()
    self.formatStringHelpButton.setText("Help")
    sequenceDateGeneralPreviewLayout.addWidget(previewLabel)
    sequenceDateGeneralPreviewLayout.addWidget(self.formatStringPreview)
    sequenceDateGeneralPreviewLayout.addWidget(self.formatStringHelpButton)
    
    sequenceDateGeneralLayout.addLayout(sequenceDateGeneralMainLayout)
    sequenceDateGeneralLayout.addLayout(sequenceDateGeneralPreviewLayout)
    optionsExtensionsLayout = QVBoxLayout(optionsExtensionsPage)
    self.extensionsListEdit = KEditListBox()
    extensionsButtonGroup =  QGroupBox()
    self.downloadAllButton = QRadioButton()
    self.downloadAllButton.setText("Download All")
    self.downloadFallbackButton = QRadioButton()
    self.downloadFallbackButton.setText("Fallback On Fail")
    extensionsButtonGroupLayout =  QHBoxLayout(extensionsButtonGroup)
    extensionsButtonGroupLayout.addWidget(self.downloadAllButton)
    extensionsButtonGroupLayout.addWidget(self.downloadFallbackButton)
    extensionsLabel1 = QLabel("Use '{none}' for no extension.\nThe '.' is not automatically included.")
    optionsExtensionsLayout.addWidget(self.extensionsListEdit)
    optionsExtensionsLayout.addWidget(extensionsButtonGroup)
    optionsExtensionsLayout.addWidget(extensionsLabel1)
    
    setupButtonLayout = QHBoxLayout()
    self.previewButton = QPushButton()
    self.previewButton.setText("&Preview")
    self.clearButton = QPushButton()
    self.clearButton.setText("&Clear")
    self.downloadButton = QPushButton()
    self.downloadButton.setText("&Download")
    setupButtonLayout.addWidget(self.previewButton)
    setupButtonLayout.addWidget(self.clearButton)
    setupButtonLayout.addWidget(self.downloadButton)
  
    setupLayout.addLayout(setupButtonLayout)
    
    progressLayout = QVBoxLayout(progressPage)
    self.downloadProgressTable = QTableWidget()
    self.downloadProgressTable.setColumnCount(4)
    self.downloadProgressTable.setMidLineWidth(1)
    self.downloadProgressTable.setEditTriggers(QAbstractItemView.NoEditTriggers)
    self.downloadProgressTable.setAlternatingRowColors(True)
    self.downloadProgressTable.setSelectionMode(QAbstractItemView.SingleSelection)
    self.downloadProgressTable.setSelectionBehavior(QAbstractItemView.SelectRows)
    self.downloadProgressTable.setHorizontalHeaderItem(0, QTableWidgetItem("Status"))
    self.downloadProgressTable.setHorizontalHeaderItem(1, QTableWidgetItem("Progress"))
    self.downloadProgressTable.setHorizontalHeaderItem(2, QTableWidgetItem("Remote File"))
    self.downloadProgressTable.setHorizontalHeaderItem(3, QTableWidgetItem("Local File"))
    
    progressButtonLayout = QHBoxLayout()
    self.cancelButton = QPushButton()
    self.cancelButton.setText("&Cancel")
    self.returnButton = QPushButton()
    self.returnButton.setText("&Return")
    progressButtonLayout.addWidget(self.cancelButton)
    progressButtonLayout.addWidget(self.returnButton)
    progressLayout.addWidget(self.downloadProgressTable)
    progressLayout.addLayout(progressButtonLayout)
    
    self.setMinimumSize(660, 520)
    self.show()
    self.adjustSize()
  def setInitialValues(self):
    home_directory = os.environ["HOME"]
    
    self.baseUrlEdit.setText("")
    self.downloadDirectoryEdit.setText(home_directory)
    self.downloadByDateButton.setChecked(False)
    self.downloadByNumberButton.setChecked(True)
    self.startNumberEdit.setValue(0)
    self.endNumberEdit.setValue(0)
    self.redundantZerosEdit.setValue(0)
    self.totalDigitsEdit.setValue(0)
    self.startDateEdit.setDate(QDate.currentDate())
    self.endDateEdit.setDate(QDate.currentDate())
    self.formatStringEdit.setText("")
    self.downloadFallbackButton.setChecked(True)
    self.returnButton.setEnabled(False)
    self.maxConcurrentDownloadsEdit.setValue(1)
    self.delayEdit.setValue(1000)
    self.overwriteExistingEdit.setCurrentIndex(0)
    self.dateFilterSundayButton.setChecked(True)
    self.dateFilterMondayButton.setChecked(True)
    self.dateFilterTuesdayButton.setChecked(True)
    self.dateFilterWednesdayButton.setChecked(True)
    self.dateFilterThursdayButton.setChecked(True)
    self.dateFilterFridayButton.setChecked(True)
    self.dateFilterSaturdayButton.setChecked(True)
    
  def setTestValues(self):
    #self.baseUrlEdit.setText("http://www.megatokyo.com/strips/")
    #self.startNumberEdit.setValue(1)
    #self.endNumberEdit.setValue(5)
    #self.totalDigitsEdit.setValue(4)
    #self.extensionsListEdit.insertItem('.gif')
    #self.extensionsListEdit.insertItem('.jpg')
    #self.extensionsListEdit.insertItem('.png')
    pass
  def connectUiSlots(self):
    self.previewButton.clicked.connect(self.showPreviewDialog)
    self.clearButton.clicked.connect(self.clearForms)
    self.downloadButton.clicked.connect(self.startDownload)
    self.formatStringHelpButton.clicked.connect(self.showFormatStringHelp)
    self.startNumberEdit.valueChanged.connect(self.verifyInput)
    self.endNumberEdit.valueChanged.connect(self.verifyInput)
    self.redundantZerosEdit.valueChanged.connect(self.verifyInput)
    self.totalDigitsEdit.valueChanged.connect(self.verifyInput)
    self.startDateEdit.changed.connect(self.verifyInput)
    self.endDateEdit.changed.connect(self.verifyInput)
    self.formatStringEdit.textChanged.connect(self.verifyInput)
    self.formatStringEdit.textChanged.connect(self.updateFormatStringPreview)
    self.baseUrlEdit.textChanged.connect(self.verifyInput)
    self.connect(self.downloadDirectoryEdit, SIGNAL("directoryChanged()"), self.verifyInput)
    self.downloadByNumberButton.toggled.connect(self.sequenceChanged)
    self.downloadByNumberButton.toggled.connect(self.verifyInput)
    self.downloadByDateButton.toggled.connect(self.sequenceChanged)
    self.downloadByDateButton.toggled.connect(self.verifyInput)
    self.returnButton.clicked.connect(self.returnToSetup)
    self.cancelButton.clicked.connect(self.cancelDownload)
    
  def cancelDownload(self):
    pass
    
  def returnToSetup(self):
    pass
  def sequenceChanged(self):
    pass
    
  def showPreviewDialog(self):
    pass
  
  def clearForms(self):
    pass
  
  def startDownload(self):
    pass
  
  def showFormatStringHelp(self):
    pass
  
  def verifyInput(self):
    pass 
    
  def updateFormatStringPreview(self):
    pass
