try:
    from PyKDE4.kdecore import *
    from PyKDE4.kdeui import *
    from PyKDE4.kio import KDirSelectDialog
    from PyKDE4 import kdecore, kdeui
    from PyQt4.QtCore import *
    from PyQt4.QtGui import *
    from PyQt4 import QtCore, QtGui
except:
    print("MyDirRequester is a PyKDE4 widget - it requires PyQt4 and PyKDE4 to be installed to work.")
    sys.exit(2)
    
class MyDirRequester(QWidget):
    def __init__(self, parent = None):
        QWidget.__init__(self, parent)
        self.setObjectName("MyDirRequester")
        
        self.widget = QWidget()
        self.layout = QHBoxLayout(self.widget, margin=0, spacing=-1)
        
        self.editor = KLineEdit(self.widget)
        self.editor.setReadOnly(True)
        self.editor.setObjectName("Editor")
        
        icon = QIcon(self.loadIcon('document-open-folder'))
        
        self.openFolder = QPushButton()
        self.openFolder.setFlat(True)
        self.openFolder.setIcon(icon)
        self.openFolder.setObjectName("openFolder")
        self.openFolder.setFixedHeight(24)
        self.openFolder.setFixedWidth(24)
        
        self.selectorDialog = KDirSelectDialog()
        
        self.layout.addWidget(self.editor)
        self.layout.addWidget(self.openFolder)
        
        self.setLayout(self.layout)
        self.openFolder.clicked.connect(self.launchOpener)
        self.editor.textChanged.connect(self.reportChange)
        QtCore.QObject.connect(self, QtCore.SIGNAL("directoryChanged()"),self.doNothing)

    def retranslateUi(self, MyDirRequester):
        MyDirRequester.setWindowTitle(kdecore.i18n("Form"))

    def launchOpener(self):
        unstringed = self.selectorDialog.selectDirectory(KUrl(self.editor.text()))
        stringed = QString(unstringed.url())
        self.editor.setText(stringed)
        
    def reportChange(self):
        self.emit(QtCore.SIGNAL("directoryChanged()"))
        
    def clear(self):
        self.editor.clear()
        
    def url(self):
        return KUrl(self.editor.text()).path()
        
    def setText(self, text):
        self.editor.setText(text)
        
    def doNothing(self):
        pass
    def loadIcon(self, name):
        """Loads an icon from the users current theme"""
        k = KIconLoader()
        return QIcon(k.loadIcon(name, KIconLoader.NoGroup, KIconLoader.SizeMedium))
