try:
    from PyKDE4.kdecore import *
    from PyKDE4.kdeui import *
    from PyKDE4 import kdecore, kdeui
    from PyQt4.QtCore import *
    from PyQt4.QtGui import *
    from PyQt4 import QtCore, QtGui
except:
    print("PyKDE is required to use PreviewDialog")
    sys.exit(2)

from AkanthophisCommon import *

class PreviewDialog(KDialog):
  previewProgressSignal = pyqtSignal(int, int)
  def __init__(self, parent = None):
    KDialog.__init__(self)
    self.setCaption("Preview")
    self.setButtons(KDialog.Ok)
    self.previewTable = QTableWidget()
    self.previewTable.setColumnCount(2)
    self.setMinimumSize(650,600)
    self.previewTable.setHorizontalHeaderItem(0,QTableWidgetItem("Local File"))
    self.previewTable.setHorizontalHeaderItem(1,QTableWidgetItem("Remote File"))
    self.setMainWidget(self.previewTable)
    
  def populateTable(self,downloadInfo):
    item = 0
    total = 0
    if downloadInfo["downloadMethod"] == "byDate":
      total = downloadInfo["startDate"].daysTo(downloadInfo["endDate"])
      if downloadInfo["extensionFallback"] == False:
        total = total * len(downloadInfo["extensionsList"])
      startDate = downloadInfo["startDate"]
      daysFilter = downloadInfo["daysFilter"]
      currentDate = QDate(startDate.year(), startDate.month(), startDate.day())
      while currentDate.daysTo(downloadInfo["endDate"]) > -1:
        dayOfWeek = ''
        if currentDate.dayOfWeek() == 1:
          dayOfWeek = 'Monday'
        elif currentDate.dayOfWeek() == 2:
          dayOfWeek = 'Tuesday'
        elif currentDate.dayOfWeek() == 3:
          dayOfWeek = 'Wednesday'
        elif currentDate.dayOfWeek() == 4:
          dayOfWeek = 'Thursday'
        elif currentDate.dayOfWeek() == 5:
          dayOfWeek = 'Friday'
        elif currentDate.dayOfWeek() == 6:
          dayOfWeek = 'Saturday'
        elif currentDate.dayOfWeek() == 7:
          dayOfWeek = 'Sunday'
        if dayOfWeek in daysFilter:
          dateString = processFormatString(downloadInfo["formatString"], currentDate)
          remoteString = downloadInfo["baseUrl"] + dateString
          localString = downloadInfo["downloadDirectory"] + dateString
          if downloadInfo["extensionFallback"] == True:
            localString = localString + downloadInfo["extensionsList"][0]
            remoteString = remoteString + downloadInfo["extensionsList"][0]
            self.previewTable.insertRow(item)
            self.previewTable.setItem(item, 0, QTableWidgetItem(localString))
            self.previewTable.setItem(item, 1, QTableWidgetItem(remoteString))
            self.previewProgressSignal.emit(item, total)
            item += 1
          else:
            for extension in downloadInfo["extensionsList"]:
              if not extension == "{none}":
                localStringBuff = localString + extension
                remoteStringBuff = remoteString + extension
              else:
                localStrinBuff = localString
                remoteStringBuff = remoteString
              self.previewTable.insertRow(item)
              self.previewTable.setItem(item, 0, QTableWidgetItem(localStringBuff))
              self.previewTable.setItem(item, 1, QTableWidgetItem(remoteStringBuff))
              self.previewProgressSignal.emit(item, total)
              item += 1
        else:
          print("Ruh uh raggy")
          print(dayOfWeek)
          print(daysFilter)
        currentDate = currentDate.addDays(1)
        print(currentDate.day())
        
    elif downloadInfo["downloadMethod"] == "byNumber":
      currentNumber = downloadInfo["startNumber"]
      item = 0
      total = downloadInfo["endNumber"] - downloadInfo["startNumber"]
      redundantZerosString = makeRedundantZerosString(downloadInfo["redundantZeros"])
      while currentNumber <= downloadInfo["endNumber"]:
        leadingZerosString = makeLeadingZerosString(currentNumber, downloadInfo["totalDigits"])
        remoteString = QString(downloadInfo["baseUrl"] + redundantZerosString + leadingZerosString + str(currentNumber))
        localString = QString(downloadInfo["downloadDirectory"] + redundantZerosString + leadingZerosString + str(currentNumber))
        if downloadInfo["extensionFallback"] == True:
          localString = localString + downloadInfo["extensionsList"][0]
          remoteString = remoteString + downloadInfo["extensionsList"][0]
          self.previewTable.insertRow(item)
          self.previewTable.setItem(item, 0, QTableWidgetItem(localString))
          self.previewTable.setItem(item, 1, QTableWidgetItem(remoteString))
          self.previewProgressSignal.emit(item, total)
          item += 1
          currentNumber = currentNumber + 1
        elif downloadInfo["extensionFallback"] == False:
          for extension in downloadInfo["extensionsList"]:
            localStringBuff = localString + extension
            remoteStringBuff = remoteString + extension
            self.previewTable.insertRow(item)
            self.previewTable.setItem(item, 0, QTableWidgetItem(localStringBuff))
            self.previewTable.setItem(item, 1, QTableWidgetItem(remoteStringBuff))
            self.previewProgressSignal.emit(item, total)
            item += 1
          currentNumber = currentNumber + 1
      self.previewTable.resizeColumnToContents(0)
      self.previewTable.resizeColumnToContents(1)
